<?php 
if(strlen(session_id()) < 1)
session_start();
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
require_once('../modelos/Retorno.php');

$retorno=new Retorno();

$idretorno=isset($_POST["idretorno"])? limpiarCadena($_POST["idretorno"]):"";
$idtecnico=isset($_POST["idtecnico"])? limpiarCadena($_POST["idtecnico"]):"";
$idusuario=$_SESSION["idusuario"];
$fecha_hora=isset($_POST["fecha_hora"])? limpiarCadena($_POST["fecha_hora"]):"";
$descripcion=isset($_POST["descripcion"])? limpiarCadena($_POST["descripcion"]):"";

switch ($_GET["op"])
{
    case 'guardaryeditar':
      if(empty($idretorno))
      {
        $rspta=$retorno->insertar($idtecnico,$idusuario,$fecha_hora,$descripcion,$_POST["idmovimiento_materiales"],$_POST["idarticulo"],$_POST["codigo"],$_POST["marca"],$_POST["cantidad"],$_POST["mac"],$_POST["estadomaterial"],$_POST["precio_venta"], $_POST["precio_compra"], $_POST["idaveria"], $_POST["estado"],$_POST["cantidadusado"],$_POST["cantidaddevuelto"],$_POST["cantidadsalida"],$_POST["idalmacen"]);
        echo $rspta ? "Retorno Registrado" : "Retorno no se pudo registrar";
      }
      else {
          //$rspta=$retorno->editar($idingreso,$idproveedor,$tipo_comprobante,$serie_comprobante,$numero_comprobante,$fecha_hora);
          //echo $rspta ? "Compra Actualizada" : "Compra no se pudo actualizar";
      }
    break;

    case 'guardaryeditarAntiguo':
      if(empty($idretorno))
      {
        $rspta=$retorno->insertarAntiguo($idtecnico,$idusuario,$fecha_hora,$descripcion,$_POST["idarticulo"],$_POST["codigo"],$_POST["marca"],$_POST["cantidad"],$_POST["mac"],$_POST["serie"],$_POST["nrofactura"],$_POST["idprovedor"],$_POST["garantia"],$_POST["estadomaterial"],$_POST["precio_venta"]);
        echo $rspta ? "Retorno Registrado" : "Retorno no se pudo registrar";
      }
      else {
          //$rspta=$retorno->editar($idingreso,$idproveedor,$tipo_comprobante,$serie_comprobante,$numero_comprobante,$fecha_hora);
          //echo $rspta ? "Compra Actualizada" : "Compra no se pudo actualizar";
      }
    break;


    case 'mostrardetalleretorno':
      $idretorno = isset($_GET['id']) ? intval($_GET['id']) : 0;
      $rspta = $retorno->mostrardetalleretorno($idretorno);
      echo json_encode($rspta);
  break;

    case 'eliminar':
      $rspta=$retorno->eliminar($idretorno);
       //Codificar el resultado utilizando json
       echo json_encode($rspta);
    break;


    case 'listarretorno':
      $rspta=$retorno->listarretorno();
      //Vamos a declarar un array
      $data=Array();
      while($reg=$rspta->fetch_object())
      {
        $url="../../reportes/reporteretorno.php?id=";
        $url_ticket="ticket_retorno.php?id=";
        //$newDate = date_format(date_create_from_format('Y-m-d', $reg->fecharetorno), 'd-m-Y'); 
        $estado='<button class="btn btn-danger btn-xs btn-flat">Retorno</button>'; 
      
        $data[]=array(
          "0"=>$reg->fecharetorno,
          "1"=>$reg->descripcion,
          "2"=>$reg->responsable,
          "3"=>$reg->usuario,
          "4"=>$reg->ano.'-00'.$reg->idretorno,
          "5"=>$estado,
          "6"=>'<button class="btn btn-warning  btn-xs btn-flat open-AddImgDialog" onclick="mostrardetalleretorno(' . $reg->idretorno . ')" data-toggle="modal" data-target="#modalProductoRetorno" ><i class="fa fa-folder-open"></i></button>'.
            ' <a target="_blank" href='.$url.$reg->idretorno.'> <button class="btn btn-danger btn-xs btn-flat"><i class="fa fa-file-excel"></i></button> </a>'.
            ' <a target="_blank" href='.$url_ticket.$reg->idretorno.'> <button class="btn btn-primary btn-xs btn-flat"><i class="fa fa-file"></i></button> </a>'
        );
      }
      $results= array(
        "sEcho"=>1, //Informacion para el datatable
        "iTotalRecords"=>count($data),//Enviamos el total de registtros en el datatable
        "iTotalDisplayRecords"=>count($data),//enviamos el total de registros a visualizar
        "aaData"=>$data);
      echo json_encode($results);

    break;

    case 'listarproductoM':

        $idtecnico=$_REQUEST["idtecnico"];
        $rspta=$retorno->listarproductoM($idtecnico);
        //Vamos a declarar un array
        $data= Array();
    
        while ($reg=$rspta->fetch_object()){

              $suma = $reg->cantidaddevuelto + $reg->cantidadusado;
              $total = $reg->cantidadsalida - $suma;

             if($reg->estado == '1'){
                $esta='<button class="btn btn-success btn-xs btn-flat">'.$total.'</button>';
                $stock=$total;
              }else{
                $esta='<button class="btn btn-danger btn-xs btn-flat">'.$total.'</button>';
                $stock=$total;
              }

            
            if($reg->estadomaterial==1){
                $mat='<button class="btn btn-success btn-xs btn-flat">Nuevo</button>';
               }else if($reg->estadomaterial==2){
                $mat='<button class="btn btn-danger btn-xs btn-flat">Usado</button>';
               }else if($reg->estadomaterial==3){
                $mat='<button class="btn btn-primary btn-xs btn-flat">Reparado</button>';
               }else if($reg->estadomaterial==4){
                $mat='<button class="btn btn-danger btn-xs btn-flat">Malogrado</button>';
               }
               
               if($reg->idaveria>1){
               $mov='<button class="btn btn-danger btn-xs btn-flat">Instalado</button>';
               }else{
               $mov='<button class="btn btn-primary btn-xs btn-flat">Disponible</button>';
               }

          $data[]=array(
            "0"=>$reg->nombre,
            "1"=>$reg->codigo,
            "2"=>$reg->mac,
            "3"=>$mat,
            "4"=>$mov,
            "5"=>$reg->cantidadsalida,
            "6"=>$reg->cantidaddevuelto,
            "7"=>$reg->cantidadusado,
            "8"=>$esta,
            "9"=>$reg->precio_venta,
            "10"=>'<button class="btn btn-warning btn-xs btn-flat"  onclick="agregarDetalle('.$reg->idarticulo.',\''.$reg->nombre.'\',\''.$reg->marca.'\',\''.$reg->mac.'\','.$reg->precio_compra.',\''.$reg->codigo.'\',\''.$reg->estadomaterial.'\','.$reg->precio_venta.','.$stock.','.$reg->idaveria.','.$reg->estado.','.$reg->cantidadusado.','.$reg->cantidaddevuelto.', '.$reg->cantidadsalida.' ,'.$reg->idalmacen .',' .$reg->idmovimiento_materiales .', this)" data-id="'.$reg->idarticulo.'"><span class="fa fa-plus"></span></button>'
            );
        }
        $results= array(
          "sEcho"=>1, //Informacion para el datatable
          "iTotalRecords"=>count($data),//Enviamos el total de registtros en el datatable
          "iTotalDisplayRecords"=>count($data),//enviamos el total de registros a visualizar
          "aaData"=>$data);
        echo json_encode($results);
     break;

     case 'listarArticulos':
      require_once "../modelos/Producto.php";
      $producto = new Producto();
      $rspta = $producto->listarArticulos();
      
      $data = [];
      while ($reg = $rspta->fetch_object()) {
          $data[] = [
              "0" => $reg->nombre,
              "1" => $reg->categoria,
              "2" => $reg->codigo,       
              "3" => $reg->afectacion,
              "4" => '<button class="btn btn-success btn-xs btn-flat" onclick="agregarDetalle(' . $reg->idarticulo . ', \'' . $reg->codigo . '\', \'' . $reg->nombre . '\' ,\'' . $reg->nroproducto . '\', this)" data-id="'.$reg->idarticulo.'"><span class="fa fa-plus"></span></button>'
          ];
      }
      echo json_encode([
          "sEcho" => 1, 
          "iTotalRecords" => count($data), 
          "iTotalDisplayRecords" => count($data),
          "aaData" => $data
      ]);
      break;

    

    
}
?>